
#ifndef _SKFAPI_H_
#define _SKFAPI_H_

#pragma pack(1)

#define SAR_OK							0x00000000	//ɹ
#define SAR_FAIL						0x0A000001	//ʧ
#define SAR_UNKNOWNERR					0x0A000002	//쳣
#define SAR_NOTSUPPORTYETERR			0x0A000003	//ֵ֧ķ
#define SAR_FILEERR						0x0A000004	//ļ
#define SAR_INVALIDHANDLEERR			0x0A000005	//Чľ
#define SAR_INVALIDPARAMERR				0x0A000006	//ЧĲ
#define SAR_READFILEERR					0x0A000007	//ļ
#define SAR_WRITEFILEERR				0x0A000008	//дļ
#define SAR_NAMELENERR					0x0A000009	//Ƴȴ
#define SAR_KEYUSAGEERR					0x0A00000A	//Կ;
#define SAR_MODULUSLENERR				0x0A00000B	//ģĳȴ
#define SAR_NOTINITIALIZEERR 			0x0A00000C	//δʼ
#define SAR_OBJERR						0x0A00000D	//
#define SAR_MEMORYERR					0x0A00000E	//ڴ
#define SAR_TIMEOUTERR					0x0A00000F	//ʱ
#define SAR_INDATALENERR				0x0A000010	//ݳȴ
#define SAR_INDATAERR					0x0A000011	//ݴ
#define SAR_GENRANDERR					0x0A000012	//
#define SAR_HASHOBJERR					0x0A000013	//HASH
#define SAR_HASHERR						0x0A000014	//HASH
#define SAR_GENRSAKEYERR				0x0A000015	//RSAԿ
#define SAR_RSAMODULUSLENERR			0x0A000016	//RSAԿģ
#define SAR_CSPIMPRTPUBKEYERR			0x0A000017	//CSP빫Կ
#define SAR_RSAENCERR					0x0A000018	//RSAܴ
#define SAR_RSADECERR					0x0A000019	//RSAܴ
#define SAR_HASHNOTEQUALERR				0x0A00001A	//HASHֵ
#define SAR_KEYNOTFOUNTERR				0x0A00001B	//δԿ
#define SAR_CERTNOTFOUNTERR				0x0A00001C	//δ֤
#define SAR_NOTEXPORTERR				0x0A00001D	//δ
#define SAR_DECRYPTPADERR				0x0A00001E	//ʱ
#define SAR_MACLENERR					0x0A00001F	//MACȴ
#define SAR_BUFFER_TOO_SMALL			0x0A000020	//
#define SAR_KEYINFOTYPEERR				0x0A000021	//Կʹ
#define SAR_NOT_EVENTERR				0x0A000022	//¼
#define SAR_DEVICE_REMOVED				0x0A000023	//豸Ƴ
#define SAR_PIN_INCORRECT				0x0A000024	//PIN
#define SAR_PIN_LOCKED					0x0A000025	//PIN
#define SAR_PIN_INVALID					0x0A000026	//PINЧ
#define SAR_PIN_LEN_RANGE				0x0A000027	//PINȴ
#define SAR_USER_ALREADY_LOGGED_IN		0x0A000028	//ûѾ¼
#define SAR_USER_PIN_NOT_INITIALIZED	0x0A000029	//ûгʼû
#define SAR_USER_TYPE_INVALID			0x0A00002A	//PINʹ
#define SAR_APPLICATION_NAME_INVALID	0x0A00002B	//ӦЧ
#define SAR_APPLICATION_EXISTS			0x0A00002C	//ӦѾ
#define SAR_USER_NOT_LOGGED_IN			0x0A00002D	//ûûе¼
#define SAR_APPLICATION_NOT_EXISTS		0x0A00002E	//Ӧò
#define SAR_FILE_ALREADY_EXIST			0x0A00002F	//ļѾ
#define SAR_NO_ROOM						0x0A000030	//洢ռ䲻
#define SAR_FILE_NOT_EXIST				0x0A000031	//ļ
#define SAR_REACH_MAX_CONTAINER_COUNT	0x0A000032	//Ѵﵽɹ

#define SAR_SECURITY_INVALID			0x0B000033	//ȫ״̬
#define SAR_OFFSET_VOER_FILE			0x0B000034	//ָƵļ
#define SAR_CONTAINER_NOT_FOUND			0x0B000035	//
#define SAR_CONTAINER_EXIST				0x0B000036	//Ѵ
#define SAR_AUTH_LOCKED					0x0B000037	//豸֤
#define SAR_ECCENCERR					0x0B000038	//ECCܴ

#ifdef WIN32
#define DEVAPI  __stdcall
#else
#define DEVAPI
#endif


#ifdef __cplusplus
extern "C" {
#endif


	typedef signed char         INT8;
	typedef signed short        INT16;
	typedef signed int          INT32;
	typedef unsigned char       UINT8;
	typedef unsigned short      UINT16;
	typedef unsigned int	    UINT32;

	typedef UINT8				BYTE;
	typedef char				CHAR;
	typedef INT16				SHORT;
	typedef UINT16				USHORT;
	typedef long				LONG;
#ifdef WIN32
	typedef unsigned long		ULONG;
#else
	typedef unsigned int		ULONG;				
#endif
	typedef UINT32				UINT;
	typedef UINT16				WORD;
	typedef UINT32				FLAGS;
	typedef void *				HANDLE;
	typedef int					BOOL;

	typedef HANDLE				DEVHANDLE;
	typedef HANDLE				HAPPLICATION;
	typedef HANDLE				HCONTAINER;

#define MAX_IV_LEN						32	//ʼ󳤶
#define	MAX_FILE_NAME_LEN				32	//ļ󳤶
//#define MAX_CONTAINER_NAME_LEN			128	//󳤶
#define MIN_PIN_LEN						6	//СPIN

#define MAX_RSA_MODULUS_LEN				256	//RSA㷨ģ󳤶
#define MAX_RSA_EXPONENT_LEN			4	//RSA㷨ָ󳤶

#define ECC_MAX_XCOORDINATE_BITS_LEN	512	//ECC㷨X󳤶
#define ECC_MAX_YCOORDINATE_BITS_LEN	512	//ECC㷨Y󳤶
#define ECC_MAX_MODULUS_BITS_LEN		512	//ECC㷨ģ󳤶


#define SGD_SM1_ECB				0x00000101	//SM1㷨ECBģʽ
#define SGD_SM1_CBC				0x00000102	//SM1㷨CBCģʽ
#define SGD_SM1_CFB				0x00000104	//SM1㷨CFBģʽ
#define SGD_SM1_OFB				0x00000108	//SM1㷨OFBģʽ
#define SGD_SM1_MAC				0x00000110	//SM1㷨MAC
#define SGD_SSF33_ECB			0x00000201	//SSF33㷨ECBģʽ
#define SGD_SSF33_CBC			0x00000202	//SSF33㷨CBCģʽ
#define SGD_SSF33_CFB			0x00000204	//SSF33㷨CFBģʽ
#define SGD_SSF33_OFB			0x00000208	//SSF33㷨OFBģʽ
#define SGD_SSF33_MAC			0x00000210	//SSF33㷨MAC
#define SGD_SM4_ECB				0x00000401	//SMS4㷨ECBģʽ
#define SGD_SM4_CBC				0x00000402	//SMS4㷨CBCģʽ
#define SGD_SM4_CFB				0x00000404	//SMS4㷨CFBģʽ
#define SGD_SM4_OFB				0x00000408	//SMS4㷨OFBģʽ
#define SGD_SM4_MAC				0x00000410	//SMS4㷨MAC

//ǶԳ㷨ʶ
#define SGD_RSA					0x00010000	//RSA㷨
#define SGD_SM2_1				0x00020100	//Բǩ㷨
#define SGD_SM2_2				0x00020200	//ԲԿЭ
#define SGD_SM2_3				0x00020400	//Բ߼㷨

//Ӵ㷨ʶ
#define SGD_SM3					0x00000001	//SM3Ӵ㷨
#define SGD_SHA1				0x00000002	//SHA1Ӵ㷨
#define SGD_SHA256				0x00000004	//SHA256Ӵ㷨

//豸״̬
#define	DEV_ABSENT_STATE		0x00000000	//豸
#define	DEV_PRESENT_STATE		0x00000001	//豸
#define DEV_UNKNOW_STATE        0x00000002   //豸״̬δ֪

//豸Ȩ
#define SECURE_NEVER_ACCOUNT	0x00000000	//
#define SECURE_ADM_ACCOUNT		0x00000001	//ԱȨ
#define SECURE_USER_ACCOUNT		0x00000010	//ûȨ
#define SECURE_EVERYONE_ACCOUNT	0x000000FF	//κ


//PIN
#define	ADMIN_TYPE				0x00000000	// ԱPIN
#define USER_TYPE				0x00000001	// ûPIN

typedef struct Struct_Version{
	BYTE	major;	//汾
	BYTE	minor;	//ΰ汾
} VERSION;


typedef struct Struct_DEVINFO{
	VERSION		Version;
	CHAR		Manufacturer[64];
	CHAR		Issuer[64];
	CHAR		Label[32];
	CHAR		SerialNumber[32];
	VERSION		HWVersion;
	VERSION		FirmwareVersion;
	ULONG		AlgSymCap;
	ULONG		AlgAsymCap;
	ULONG		AlgHashCap;
	ULONG		DevAuthAlgId;
	ULONG		TotalSpace;
	ULONG		FreeSpace;
	ULONG		MaxECCBufferSize;
	ULONG		MaxBufferSize;
	BYTE  		Reserved[64];
}DEVINFO,*PDEVINFO;


//RSAԿݿ
typedef struct Struct_RSAPUBLICKEYBLOB{
	ULONG	AlgID;									//㷨ʶ
	ULONG	BitLen;									//ģʵλȣ8ı
	BYTE	Modulus[MAX_RSA_MODULUS_LEN];			//ģn=p*qʵʳΪBitLen/8ֽ
	BYTE	PublicExponent[MAX_RSA_EXPONENT_LEN];	//Կe һΪ00010001
} RSAPUBLICKEYBLOB, *PRSAPUBLICKEYBLOB;


//RSA˽Կݿ
typedef struct Struct_RSAPRIVATEKEYBLOB{
	ULONG	AlgID;									//㷨ʶ
	ULONG	BitLen;									//ģʵλȣ8ı
	BYTE	Modulus[MAX_RSA_MODULUS_LEN];			//ģn=p*qʵʳΪBitLen/8ֽ
	BYTE	PublicExponent[MAX_RSA_EXPONENT_LEN];	//Կe һΪ00010001
	BYTE	PrivateExponent[MAX_RSA_MODULUS_LEN];	//˽ԿdʵʳΪBitLen/8ֽ
	BYTE	Prime1[MAX_RSA_MODULUS_LEN/2];			//pʵʳΪBitLen/16ֽ
	BYTE	Prime2[MAX_RSA_MODULUS_LEN/2];			//qʵʳΪBitLen/16ֽ
	BYTE	Prime1Exponent[MAX_RSA_MODULUS_LEN/2];	//d mod (p-1)ֵ, ʵʳΪBitLen/16ֽ
	BYTE	Prime2Exponent[MAX_RSA_MODULUS_LEN/2];	//d mod (q-1)ֵʵʳΪBitLen/16ֽ
	BYTE	Coefficient[MAX_RSA_MODULUS_LEN/2];		//qģpĳ˷ԪʵʳΪBitLen/16ֽ
} RSAPRIVATEKEYBLOB, *PRSAPRIVATEKEYBLOB;

//ECCԿݿ
typedef struct Struct_ECCPUBLICKEYBLOB{
	ULONG	BitLen;
	BYTE	XCoordinate[ECC_MAX_XCOORDINATE_BITS_LEN/8];
	BYTE	YCoordinate[ECC_MAX_YCOORDINATE_BITS_LEN/8];
}ECCPUBLICKEYBLOB, *PECCPUBLICKEYBLOB;


//ECC˽Կݿ
typedef struct Struct_ECCPRIVATEKEYBLOB{
	ULONG	BitLen;
	BYTE	PrivateKey[ECC_MAX_MODULUS_BITS_LEN/8];
}ECCPRIVATEKEYBLOB, *PECCPRIVATEKEYBLOB;



// ECCݽṹ
typedef struct Struct_ECCCIPHERBLOB{
	BYTE	XCoordinate[ECC_MAX_XCOORDINATE_BITS_LEN/8]; 
	BYTE	YCoordinate[ECC_MAX_XCOORDINATE_BITS_LEN/8]; 
	BYTE	HASH[32];
	UINT32	CipherLen;
	BYTE	Cipher[1];
} ECCCIPHERBLOB, *PECCCIPHERBLOB;


// ECCǩݽṹ
typedef struct Struct_ECCSIGNATUREBLOB{
	BYTE	r[ECC_MAX_XCOORDINATE_BITS_LEN/8];
	BYTE	s[ECC_MAX_YCOORDINATE_BITS_LEN/8];
} ECCSIGNATUREBLOB, *PECCSIGNATUREBLOB;

//ECCԿԱṹ
typedef struct Struct_ENVELOPEDKEYBLOB{
	UINT32 Version;                  // ǰ汾Ϊ 1
	UINT32 ulSymmAlgID;              // 淶е㷨ʶ޶ECBģʽ
	UINT32 ulBits;					// ԿԵԿλ
	BYTE cbEncryptedPriKey[64];     // ܱļ˽Կ
	ECCPUBLICKEYBLOB PubKey;        // ܹԿ
	ECCCIPHERBLOB ECCCipherBlob;    // SM2 ԿܵԿԿ
}ENVELOPEDKEYBLOB, *PENVELOPEDKEYBLOB;

////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////
typedef struct Struct_BLOCKCIPHERPARAM{
	BYTE	IV[MAX_IV_LEN];			//ʼMAX_IV_LENΪʼ󳤶
	ULONG	IVLen;					//ʼʵʳȣֽڼ
	ULONG	PaddingType;			//䷽ʽ0ʾ䣬1ʾPKCS#5ʽ
	ULONG	FeedBitLen;				//ֵλȣֽڼ㣬ֻOFBCFBģʽ
} BLOCKCIPHERPARAM, *PBLOCKCIPHERPARAM;

// ļ
typedef struct Struct_FILEATTRIBUTE{
	CHAR	FileName[32];
	ULONG	FileSize;
	ULONG	ReadRights;
	ULONG	WriteRights; 
}FILEATTRIBUTE, *PFILEATTRIBUTE;

#pragma pack()
/************************************************************************/
/*	1. 豸	ϵк														*/
/*	SKF_WaitForDevEvent													*/
/*	SKF_CancelWaitForDevEvent											*/
/*	SKF_EnumDev															*/
/*	SKF_ConnectDev														*/
/*	SKF_DisconnectDev													*/
/*	SKF_GetDevState														*/
/*	SKF_SetLable														*/
/*	SKF_GetDevInfo														*/
/*	SKF_LockDev															*/
/*	SKF_UnlockDev														*/
/*	SKF_Transmit														*/
/************************************************************************/

/*
*	ȴ豸Ĳ¼
*	szDevName		[OUT]ط¼豸
*	pulDevNameLen	[IN,OUT]/ʱʾȣʱʾ豸ƵЧ,Ȱַ
*	pulEvent		[OUT]¼͡1ʾ룬2ʾγ
*	ע: úõ
*/
ULONG DEVAPI SKF_WaitForDevEvent(LPSTR szDevName,ULONG *pulDevNameLen, ULONG *pulEvent);
ULONG DEVAPI SKF_CancelWaitForDevEvent();

/*
*	õǰϵͳе豸б
*	bPresent		[IN]ΪTRUEʾȡǰ豸״̬Ϊڵ豸бΪFALSEʾȡǰֵ֧豸б
*	szNameList		[OUT]豸бòΪNULLpulSizeҪڴռСÿ豸Ե'\0'˫'\0'ʾбĽ
*	pulSize			[IN,OUT]豸бĻȣszNameListҪĿռС
*/
ULONG DEVAPI SKF_EnumDev(BOOL bPresent, LPSTR szNameList, ULONG *pulSize);
/*
*	ͨ豸豸豸ľ
*	szName		[IN]豸
*	phDev		[OUT]豸
*/
ULONG DEVAPI SKF_ConnectDev (LPSTR szName, DEVHANDLE *phDev);
/*
*	ϿһѾӵ豸ͷž
*	hDev		[IN]豸ʱص豸
*/
ULONG DEVAPI SKF_DisConnectDev (DEVHANDLE hDev);
/*
*	ȡ豸Ƿڵ״̬
*	szDevName	[IN]
*	pulDevState	[OUT]豸״̬
*/
ULONG DEVAPI SKF_GetDevState(LPSTR szDevName, ULONG *pulDevState);
/*
*	豸ǩ
*	hDev		[IN]豸ʱص豸
*	szLabel		[OUT]豸ǩַַӦС32ֽ
*/
ULONG DEVAPI SKF_SetLabel(DEVHANDLE hDev, LPSTR szLabel);
/*
*	ȡ豸һЩϢ豸ǩϢֵ֧㷨
*	hDev		[IN]豸ʱص豸
*	pDevInfo	[OUT]豸Ϣ
*/
ULONG DEVAPI SKF_GetDevInfo (DEVHANDLE hDev, DEVINFO *pDevInfo);
/*
*	豸ĶռʹȨ
*	hDev		[IN]豸ʱص豸
*	ulTimeOut	[IN]ʱʱ䣬λΪ롣Ϊ0xFFFFFFFFʾ޵ȴ
*/	
ULONG DEVAPI SKF_LockDev (DEVHANDLE hDev, ULONG ulTimeOut);
/*
*	ͷŶ豸ĶռʹȨ
*	hDev		[IN]豸ʱص豸
*/
ULONG DEVAPI SKF_UnlockDev (DEVHANDLE hDev);

/*
*	ֱӷ͸豸ؽ
*	hDev			[IN]豸
*	pbCommand		[IN]豸
*	ulCommandLen	[IN]
*	pbData			[OUT]ؽ
*	pulDataLen		[IN,OUT]뻺ȣݳ
*/
ULONG DEVAPI SKF_Transmit(DEVHANDLE hDev, BYTE* pbCommand, ULONG ulCommandLen, BYTE* pbData, ULONG* pulDataLen);


/************************************************************************/
/*  2. ʿ	ϵк                                           */
/*	SKF_ChangeDevAuthKey												*/
/*	SKF_DevAuth															*/
/*	SKF_ChangePIN														*/
/*	SKF_GetPINInfo														*/
/*	SKF_VerifyPIN														*/
/*	SKF_UnblockPIN														*/
/*	SKF_ClearSecureState												*/
/************************************************************************/

/*
*	豸֤Կ
*	hDev		[IN]ʱص豸
*	pbKeyValue	[IN]Կֵ
*	ulKeyLen	[IN]Կ
*/
ULONG DEVAPI SKF_ChangeDevAuthKey (DEVHANDLE hDev, BYTE *pbKeyValue, ULONG ulKeyLen);

/*
*	豸֤豸Ӧó֤
*	hDev			[IN]ʱص豸
*	pbAuthData		[IN]֤
*	ulLen			[IN]֤ݵĳ
*/
ULONG DEVAPI SKF_DevAuth (DEVHANDLE hDev, BYTE *pbAuthData,ULONG ulLen);
/*
*	޸PIN޸AdminUserPINԭPIN󣬷ʣԴʣΪ0ʱʾPINѾ
*	hApplication	[IN]Ӧþ
*	ulPINType		[IN]PINͣΪADMIN_TYPE=0USER_TYPE=1
*	szOldPIN		[IN]ԭPINֵ
*	szNewPIN		[IN]PINֵ
*	pulRetryCount	[OUT]Դ
*/
ULONG DEVAPI SKF_ChangePIN (HAPPLICATION hApplication, ULONG ulPINType, LPSTR szOldPin, LPSTR szNewPin, ULONG *pulRetryCount);

/*
*	ȡPINϢԴǰʣԴԼǰPINǷΪĬPIN
*	hApplication		[IN]Ӧþ
*	ulPINType			[IN]PIN
*	pulMaxRetryCount	[OUT]Դ
*	pulRemainRetryCount	[OUT]ǰʣԴΪ0ʱʾ
*	pbDefaultPin		[OUT]ǷΪĬPIN
*/
ULONG DEVAPI SKF_GetPINInfo(HAPPLICATION hApplication, ULONG  ulPINType, ULONG *pulMaxRetryCount, ULONG *pulRemainRetryCount, BOOL *pbDefaultPin);

/*
*	УPIN롣Уɹ󣬻ӦȨޣPIN󣬻᷵PINԴԴΪ0ʱʾPINѾ
*	hApplication	[IN]Ӧþ
*	ulPINType		[IN]PINͣΪADMIN_TYPE=0USER_TYPE=1
*	szPIN			[IN]PINֵ
*	pulRetryCount	[OUT]󷵻صԴ
*/
ULONG DEVAPI SKF_VerifyPIN (HAPPLICATION hApplication, ULONG  ulPINType, LPSTR szPIN, ULONG *pulRetryCount);
/*
*	ûPINͨøúûPIN롣
*	ûPIN뱻óֵûPINԴҲָԭֵ
*	hApplication	[IN]Ӧþ
*	szAdminPIN		[IN]ԱPIN
*	szNewUserPIN	[IN]µûPIN
*	pulRetryCount	[OUT]ԱPINʱʣԴ
*/
ULONG DEVAPI SKF_UnblockPIN (HAPPLICATION hApplication, LPSTR szAdminPIN, LPSTR szNewUserPIN,  ULONG *pulRetryCount);


ULONG DEVAPI SKF_GenRemoteUnblockRequest(HAPPLICATION hApplication, BYTE *pbRandom,ULONG ulRandomLen);

/*
*	ûPINͨøúûPIN롣
*	ûPIN뱻óֵûPINԴҲָԭֵ
*	hApplication	[IN]Ӧþ
*	pbCipherPIN		[IN]ԱPINsha1ȡ16λΪKEYKEYµûPINõģKEYMACӵĵĺ
*	pulRetryCount	[OUT]ԱPINʱʣԴ
*/
ULONG DEVAPI SKF_RemoteUnblockPIN (HAPPLICATION hApplication, BYTE *pbCipherPIN, ULONG ulCipherPINLen,  ULONG *pulRetryCount);

/*
*	Ӧõǰİȫ״̬
*	hApplication	[IN]Ӧþ
*/
ULONG DEVAPI SKF_ClearSecureState (HAPPLICATION hApplication);

/************************************************************************/
/*  3. Ӧùϵк                                           */
/*	SKF_CreateApplication												*/
/*	SKF_EnumApplication													*/
/*	SKF_DeleteApplication												*/
/*	SKF_OpenApplication													*/
/*	SKF_CloseApplication												*/
/************************************************************************/

/*
*	һӦ
*	hDev					[IN]豸ʱص豸
*	szAppName				[IN]Ӧ
*	szAdminPIN				[IN]ԱPIN
*	dwAdminPinRetryCount	[IN]ԱPINԴ
*	szUserPIN				[IN]ûPIN
*	dwAdminPinRetryCount	[IN]ûPINԴ
*	dwCreateFileRights		[IN]ڸӦ´ļȨ
*	phApplication			[OUT]Ӧõľ
*/
ULONG DEVAPI SKF_CreateApplication(DEVHANDLE hDev, LPSTR szAppName, LPSTR szAdminPin, DWORD dwAdminPinRetryCount,LPSTR szUserPin, DWORD dwUserPinRetryCount,DWORD dwCreateFileRights, HAPPLICATION *phApplication);

/*
*	ö豸ڵӦ
*	hDev			[IN]豸ʱص豸
*	szAppName		[OUT]Ӧб, òΪգpulSizeҪڴռС
*						 ÿӦõԵ'\0'˫'\0'ʾбĽ
*	pulSize			[IN,OUT]ӦƵĻȣszAppNameռõĵĿռС
*/
ULONG DEVAPI SKF_EnumApplication(DEVHANDLE hDev, LPSTR szAppName,ULONG *pulSize);
/*
*	ɾָӦ
*	hDev			[IN]豸ʱص豸
*	szAppName		[IN]Ӧ
*/
ULONG DEVAPI SKF_DeleteApplication(DEVHANDLE hDev, LPSTR szAppName);
/*
*	ָӦ
*	hDev			[IN]豸ʱص豸
*	szAppName		[IN]Ӧ
*	phApplication	[OUT]Ӧõľ
*/
ULONG DEVAPI SKF_OpenApplication(DEVHANDLE hDev, LPSTR szAppName, HAPPLICATION *phApplication);
/*
*	رӦòͷӦþ
*	hApplication	[IN]Ӧõľ
*/
ULONG DEVAPI SKF_CloseApplication(HAPPLICATION hApplication);

/************************************************************************/
/*  4. ļ				                                            */
/*	SKF_CreateFile														*/
/*	SKF_DeleteFile														*/
/*	SKF_EnumFiles														*/
/*	SKF_GetFileInfo														*/
/*	SKF_ReadFile														*/
/*	SKF_WriteFile														*/
/************************************************************************/

/*
*	һļļʱҪָļƣСԼļĶдȨ
*	hApplication		[IN]Ӧþ
*	szFileName			[IN]ļƣȲô32ֽ
*	ulFileSize			[IN]ļС
*	ulReadRights		[IN]ļȨ
*	ulWriteRights		[IN]ļдȨ
*/
ULONG DEVAPI SKF_CreateFile (HAPPLICATION hApplication, LPSTR szFileName, ULONG ulFileSize, ULONG ulReadRights,ULONG ulWriteRights);

/*
*	ɾָļļɾļдϢʧļ豸еռõĿռ佫ͷš
*	hApplication		[IN]ҪɾļڵӦþ
*	szFileName			[IN]Ҫɾļ
*/
ULONG DEVAPI SKF_DeleteFile (HAPPLICATION hApplication, LPSTR szFileName);
/*
*	öһӦ´ڵļ
*	hApplication		[IN]Ӧõľ
*	szFileList			[OUT]ļбòΪգpulSizeļϢҪĿռСÿļԵ'\0'˫'\0'ʾбĽ
*	pulSize				[OUT]ΪݻĴСΪʵļƵĴС
*/
ULONG DEVAPI SKF_EnumFiles (HAPPLICATION hApplication, LPSTR szFileList, ULONG *pulSize);

/*
*	ȡӦļϢļĴСȨ޵
*	hApplication		[IN]ļӦõľ
*	szFileName			[IN]ļ
*	pFileInfo			[OUT]ļϢָļԽṹָ
*/
ULONG DEVAPI SKF_GetFileInfo (HAPPLICATION hApplication, LPSTR szFileName, FILEATTRIBUTE *pFileInfo);

/*
*	ȡļ
*	hApplication		[IN]ļڵӦþ
*	szFileName			[IN]ļ
*	ulOffset			[IN]ļȡƫλ
*	ulSize				[IN]Ҫȡĳ
*	pbOutData			[OUT]ݵĻ
*	pulOutLen			[OUT]ʾĻСʾʵʶȡصݴС
*/
ULONG DEVAPI SKF_ReadFile (HAPPLICATION hApplication, LPSTR szFileName, ULONG ulOffset, ULONG ulSize, BYTE * pbOutData, ULONG *pulOutLen);

/*
*	дݵļ
*	hApplication		[IN]ļڵӦþ
*	szFileName			[IN]ļ
*	ulOffset			[IN]дļƫ
*	pbData				[IN]дݻ
*	ulSize				[IN]дݵĴС
*/
ULONG DEVAPI SKF_WriteFile (HAPPLICATION hApplication, LPSTR szFileName, ULONG  ulOffset, BYTE *pbData, ULONG ulSize);


/************************************************************************/
/*  5. 	ϵк                                           */
/*	SKF_CreateContainer													*/
/*	SKF_DeleteContainer													*/
/*	SKF_EnumContainer													*/
/*	SKF_OpenContainer													*/
/*	SKF_CloseContainer													*/
/*	SKF_GetContainerType												*/
/*	SKF_ImportCertificate												*/
/*	SKF_ExportCertificate												*/
/************************************************************************/

/*
*	Ӧ½ָƵ
*	hApplication		[IN]Ӧþ
*	szContainerName		[IN]ASCIIַʾƣƵ󳤶Ȳܳ64ֽ
*	phContainer			[OUT]
*/
ULONG DEVAPI SKF_CreateContainer (HAPPLICATION hApplication, LPSTR szContainerName, HCONTAINER *phContainer);
/*
*	ӦɾָƵͷصԴ
*	hApplication		[IN]Ӧþ
*	szContainerName		[IN]ָɾ
*/
ULONG DEVAPI SKF_DeleteContainer(HAPPLICATION hApplication, LPSTR szContainerName);
/*
*	öӦµб
*	hApplication		[IN]Ӧþ
*	szContainerName		[OUT]ָб˲ΪNULLʱpulSizeʾҪĳȣ˲ΪNULLʱбÿԵ'\0'Ϊб˫'\0'
*	pulSize				[OUT]ǰʾszContainerNameĳȣбĳ
*/
ULONG DEVAPI SKF_EnumContainer(HAPPLICATION	hApplication, LPSTR  szContainerName, ULONG* pulSize);
/*
*	ȡ
*	hApplication		[IN]Ӧþ
*	szContainerName		[IN]
*	phContainer			[OUT]ľ
*/
ULONG DEVAPI SKF_OpenContainer(HAPPLICATION hApplication,LPSTR szContainerName,HCONTAINER *phContainer);

/*
*	رͷԴ
*	hContainer			[OUT]
*/
ULONG DEVAPI SKF_CloseContainer(HCONTAINER hContainer);

/*
ȡ
hContainer	[IN] 
pulContainerType	[OUT] õֵָָ͡Ϊ0ʾδδͻΪΪ1ʾΪRSAΪ2ʾΪECC
*/
ULONG DEVAPI SKF_GetContainerType(HCONTAINER hContainer, ULONG *pulContainerType);

/*
ڵ֤
hContainer	[IN] 
bSignFlag	[IN] TRUEʾǩ֤飬FALSEʾ֤
pbCert		[IN] ֤黺
ulCertLen	[IN] 
*/
ULONG DEVAPI SKF_ImportCertificate(HCONTAINER hContainer, BOOL bSignFlag,  BYTE* pbCert, ULONG ulCertLen);

/*
ڵ֤
hContainer	[IN] 
bSignFlag	[IN] TRUEʾǩ֤飬FALSEʾ֤
pbCert		[OUT] ֤黺
ulCertLen	[IN,OUT] 뻺ȣ֤ݳ
*/
ULONG DEVAPI SKF_ExportCertificate(HCONTAINER hContainer, BOOL bSignFlag,  BYTE* pbCert, ULONG *pulCertLen);

/************************************************************************/
/*  6. 	ϵк                                           */
/*	SKF_GetRandom														*/
/*	SKF_GenRSAKeyPair													*/
/*	SKF_ImportRSAKeyPair												*/
/*	SKF_RSASignData														*/
/*	SKF_RSAVerify														*/
/*	SKF_RSAExportSessionKey												*/
/*	SKF_GenECCKeyPair													*/
/*	SKF_ImportECCKeyPair												*/
/*	SKF_ECCSignData														*/
/*	SKF_ECCVerify														*/
/*	SKF_GenerateAgreementDataWithECC									*/
/*	SKF_GenerateAgreementDataAndKeyWithECC								*/
/*	SKF_GenerateKeyWithECC												*/
/*	SKF_ECCExportSessionKey												*/
/*	SKF_ExportPublicKey													*/
/*	SKF_ImportSessionKey												*/
/*	SKF_EncryptInit														*/
/*	SKF_Encrypt															*/
/*	SKF_EncryptUpdate													*/
/*	SKF_EncryptFinal													*/
/*	SKF_DecryptInit														*/
/*	SKF_Decrypt															*/
/*	SKF_DecryptUpdate													*/
/*	SKF_DecryptFinal													*/
/*	SKF_DigestInit														*/
/*	SKF_Digest															*/
/*	SKF_DigestUpdate													*/
/*	SKF_DegistFinal														*/
/*	SKF_MACInit															*/
/*	SKF_MAC																*/
/*	SKF_MACUpdate														*/
/*	SKF_MACFinal														*/
/*	SKF_CloseHandle														*/
/************************************************************************/

/*
*	ָȵ
*	hDev			[IN] 豸
*	pbRandom		[OUT] ص
*	ulRandomLen		[IN] 
*/
ULONG DEVAPI SKF_GenRandom (DEVHANDLE hDev, BYTE *pbRandom,ULONG ulRandomLen);

/*
*	豸RSAԿԲ
*	hDev			[IN] 豸
*	ulBitsLen		[IN] Կģ
*	pBlob			[OUT] صĹԿݽṹ
*/
ULONG DEVAPI SKF_GenRSAKeyPair (HCONTAINER hContainer, ULONG ulBitsLen, RSAPUBLICKEYBLOB *pBlob);



/*
*	RSAܹ˽Կ
*	hContainer		[IN] 
*	ulSymAlgId		[IN] Գ㷨Կʶ
*	pbWrappedKey	[IN] ʹøǩԿĶԳ㷨Կ
*	ulWrappedKeyLen	[IN] ĶԳ㷨Կ
*	pbEncryptedData	[IN] Գ㷨ԿRSA˽Կ˽ԿĸʽѭPKCS #1 v2.1: RSA Cryptography Standardе˽Կʽ
*	ulEncryptedDataLen	[IN] Գ㷨ԿRSAܹ˽ԿԳ
*/
ULONG DEVAPI SKF_ImportRSAKeyPair ( HCONTAINER hContainer, ULONG ulSymAlgId, 
								   BYTE *pbWrappedKey, ULONG ulWrappedKeyLen,
								   BYTE *pbEncryptedData, ULONG ulEncryptedDataLen);

/*
*	ʹhContainerָǩ˽ԿָpbDataǩǩĽŵpbSignaturepulSignLenΪǩĳ
*	hContainer		[IN] ǩ˽Կ
*	pbData			[IN] ǩ
*	ulDataLen		[IN] ǩݳȣӦRSAԿģ-11
*	pbSignature		[OUT] ǩĻָ룬ֵΪNULLȡǩ
*	pulSigLen		[IN,OUT] ΪǩСΪǩ
*/
ULONG DEVAPI SKF_RSASignData(HCONTAINER hContainer, BYTE *pbData, ULONG  ulDataLen, BYTE *pbSignature, ULONG *pulSignLen);
/*
*	֤RSAǩpRSAPubKeyBlobڵĹԿֵԴǩݽǩ
*	hDev			[IN] 豸ʱص豸
*	pRSAPubKeyBlob	[IN] RSAԿݽṹ
*	pbData			[IN] ֤ǩ
*	ulDataLen		[IN] ݳȣӦڹԿģ-11
*	pbSignature		[IN] ֤ǩֵ
*	ulSigLen		[IN] ǩֵȣΪԿģ
*/
ULONG DEVAPI SKF_RSAVerify (DEVHANDLE hDev , RSAPUBLICKEYBLOB* pRSAPubKeyBlob, BYTE *pbData, ULONG  ulDataLen, 
							BYTE *pbSignature, ULONG ulSignLen);
/*
*	ɻỰԿⲿԿ
*	hContainer		[IN] 
*	ulAlgID			[IN] ỰԿ㷨ʶ
*	pPubKey			[IN] ܻỰԿRSAԿݽṹ
*	pbData			[OUT] ļܻỰԿģPKCS#1v1.5Ҫװ
*	pulDataLen		[OUT] صݳ
*	phSessionKey	[OUT] Կ
*/

ULONG DEVAPI SKF_RSAExportSessionKey (HCONTAINER hContainer, ULONG ulAlgId, RSAPUBLICKEYBLOB *pPubKey, BYTE *pbData, ULONG  *pulDataLen, HANDLE *phSessionKey);


/*
*	ֱʹⲿRSAԿPKCS1㲢
*	hDev			[IN] 豸
*	pRSAPubKeyBlob	[IN] RSAԿݽṹ
*	pbInput			[IN] ָԭʼݻ
*	ulInputLen		[IN] ԭʼݵĳȣΪԿģ
*	pbOutput		[OUT] ָRSAԿòΪNULLpulOutputLenʵʳ
*	pulOutputLen	[in, OUT] ǰʾpbOutputĳȣRSAԿʵʳ
*/
ULONG DEVAPI SKF_ExtRSAEncrypt(DEVHANDLE hDev, RSAPUBLICKEYBLOB* pRSAPubKeyBlob,BYTE* pbInput, ULONG ulInputLen, 
							   BYTE* pbOutput, ULONG* pulOutputLen);


/*
*	ECCǩԿԲǩԿ
*	hContainer		[IN] 
*	ֻ֧SGD_SM2_1㷨
*	pBlob			[OUT] ECCԿݽṹ
*/
ULONG DEVAPI SKF_GenECCKeyPair (HCONTAINER hContainer, ULONG ulAlgId, ECCPUBLICKEYBLOB *pBlob);

/*
*	ECC˽Կ
*	hContainer		[IN] 
*	pbWrapedData	[IN] ܱECCܹ˽Կ
*	ulWrapedLen		[IN] ݳ
*/

ULONG DEVAPI SKF_ImportECCKeyPair (  HCONTAINER hContainer, PENVELOPEDKEYBLOB pEnvelopedKeyBlob);

/*
*	ECCǩECC㷨ָ˽ԿhKeyָpbDataǩǩĽŵpbSignaturepulSignLenΪǩֵĳ
*	hContainer		[IN] ǩ˽Կ
*	pbData			[IN] ǩ
*	ulDataLen		[IN] ǩݳȣСԿģ
*	pbSignature		[OUT] ǩֵΪNULLʱڻǩֵĳ
*	pulSigLen		[IN,OUT] ǩֵȵָ 
*/

ULONG DEVAPI SKF_ECCSignData (HCONTAINER hContainer, BYTE *pbData, ULONG  ulDataLen, PECCSIGNATUREBLOB pSignature);

/*
*	ECCԿݽǩ
*	hDev			[IN] 豸
*	pECCPubKeyBlob	[IN] ECCԿݽṹ
*	pbData			[IN] ֤ǩ
*	ulDataLen		[IN] ݳ
*	pbSignature		[IN] ֤ǩֵ
*	ulSigLen		[IN] ǩֵ
*/
ULONG DEVAPI SKF_ECCVerify (DEVHANDLE hDev , ECCPUBLICKEYBLOB* pECCPubKeyBlob, BYTE *pbData, ULONG  ulDataLen, PECCSIGNATUREBLOB pSignature);

/*
*	ɻỰԿⲿԿ
*	hContainer		[IN] 
*	ulAlgID			[IN] ỰԿ㷨ʶ
*	pPubKey			[IN] ԿԿṹ
*	pbData			[OUT] ļܻỰԿ, ע˴ĳҪECCCIPHERBLOBṹĳȣṹںָ
*	phSessionKey	[OUT] ỰԿ
*/
ULONG DEVAPI SKF_ECCExportSessionKey (HCONTAINER hContainer, ULONG ulAlgId, ECCPUBLICKEYBLOB *pPubKey, PECCCIPHERBLOB pData, HANDLE *phSessionKey);


/*
*	ʹECCԿЭ㷨ΪỰԿЭ̲ʱECCԿԵĹԿЭ̾
*	hContainer		[IN] 
*	ulAlgId			[IN] ỰԿ㷨ʶ
*	pTempECCPubKeyBlob	[OUT] ʱECCԿ
*	pbID			[IN] 𷽵ID
*	ulIDLen			[IN] IDĳȣ32
*	phAgreementHandle	[OUT] صԿЭ̾
*/
ULONG DEVAPI SKF_GenerateAgreementDataWithECC (HCONTAINER hContainer, ULONG ulAlgId,ECCPUBLICKEYBLOB*  pTempECCPubKeyBlob,BYTE* pbID, ULONG ulIDLen,HANDLE *phAgreementHandle);

/*
*	ʹECCԿЭ㷨Э̲ỰԿʱECCԿԹԿزԿ
*	hContainer					[IN] 
*	ulAlgId						[IN] ỰԿ㷨ʶ
*	pSponsorECCPubKeyBlob		[IN] 𷽵ECCԿ
*	pSponsorTempECCPubKeyBlob	[IN] 𷽵ʱECCԿ
*	pTempECCPubKeyBlob			[OUT] ӦʱECCԿ
*	pbID						[IN] ӦID
*	ulIDLen						[IN] ӦIDĳȣ32
*	pbSponsorID					[IN] 𷽵ID
*	ulSponsorIDLen				[IN] IDĳȣ32
*	phKeyHandle					[OUT] صĶԳ㷨Կ
*/
ULONG DEVAPI SKF_GenerateAgreementDataAndKeyWithECC(
	HANDLE hContainer, ULONG ulAlgId,
	ECCPUBLICKEYBLOB*  pSponsorECCPubKeyBlob,
	ECCPUBLICKEYBLOB*  pSponsorTempECCPubKeyBlob,
	ECCPUBLICKEYBLOB*  pTempECCPubKeyBlob,
	BYTE* pbID, ULONG ulIDLen, BYTE *pbSponsorID, ULONG ulSponsorIDLen,
	HANDLE *phKeyHandle);

/*
*	ʹECCԿЭ㷨ʹЭ̾ӦЭ̲ỰԿͬʱػỰԿ
*	hAgreementHandle			[IN] ԿЭ̾
*	pECCPubKeyBlob				[IN] ⲿӦECCԿ
*	pTempECCPubKeyBlob			[IN] ⲿӦʱECCԿ
*	pbID						[IN] ӦID
*	ulIDLen						[IN] ӦIDĳȣ32
*	phKeyHandle					[OUT] صԿ
*/
ULONG DEVAPI SKF_GenerateKeyWithECC (HANDLE hAgreementHandle,
									 ECCPUBLICKEYBLOB*  pECCPubKeyBlob,
									 ECCPUBLICKEYBLOB*  pTempECCPubKeyBlob,
									 BYTE* pbID, ULONG ulIDLen, HANDLE *phKeyHandle);


/*
*	еǩԿ߼ܹԿ
*	hContainer		[IN] 
*	bSignFlag		[IN] TRUEʾǩԿFALSEʾܹԿ
*	pbBlob			[OUT] ָRSAԿṹRSAPUBLICKEYBLOBECCԿṹECCPUBLICKEYBLOB˲ΪNULLʱpulBlobLenpbBlobĳ
*	pulBlobLen		[IN,OUT] ʱʾpbBlobĳȣصԿṹĴС
*/
ULONG DEVAPI SKF_ExportPublicKey (HCONTAINER hContainer, BOOL bSignFlag, BYTE* pbBlob, ULONG* pulBlobLen);

/*
*	ỰԿ
*	hDev			[IN] 豸
*	pECCPubKeyBlob	[IN] ʹõĹԿ
*	pbPlainText		[IN] Ҫܵ
*	ulPlainTextLen	[IN] ݳ
*	pCipherText		[OUT] ص
*/
ULONG DEVAPI SKF_ExtECCEncrypt(DEVHANDLE hDev, ECCPUBLICKEYBLOB *pECCPubKeyBlob,
							   BYTE* pbPlainText, ULONG ulPlainTextLen, 
							   PECCCIPHERBLOB pCipherText);


/*
*	ỰԿ
*	hContainer		[IN] 
*	ulAlgID			[IN] ỰԿ㷨ʶ
*	pbWrapedData	[IN] Ҫ
*	ulWrapedLen		[IN] ݳ
*	phKey			[OUT] ػỰԿ
*/
ULONG DEVAPI SKF_ImportSessionKey (HCONTAINER hContainer, ULONG ulAlgId,BYTE *pbWrapedData,ULONG ulWrapedLen,HANDLE *phKey);


/*
*	ݼܳʼݼܵ㷨ز
*	hKey			[IN] Կ
*	EncryptParam	[IN] 㷨ز㷨ʶšԿȡʼʼȡ䷽ģʽֵλ
*/
ULONG DEVAPI SKF_EncryptInit (HANDLE hKey, BLOCKCIPHERPARAM EncryptParam);

/*
*	һݵļܲ
ָԿָݽмܣֻܵһ飬ܺı浽ָĻС
SKF_EncryptֻԵݽмܣڵSKF_Encrypt֮ǰSKF_EncryptInitʼܲ
SKF_EncyptȼȵSKF_EncryptUpdateٵSKF_EncryptFinal
*	hKey			[IN] Կ
*	pbData			[IN] 
*	ulDataLen		[IN] ݳ
*	pbEncryptedData [OUT] ܺݻָ
*	pulEncryptedLen [IN,OUT] 룬ĻСؼܺ

*	ɹ: SAR_OK
*	ʧ: SAR_FAIL SAR_MEMORYERR SAR_UNKNOWNERR  SAR_INVALIDPARAMERR SAR_BUFFER_TOO_SMALL   
*/
ULONG DEVAPI SKF_Encrypt(HANDLE hKey, BYTE * pbData, ULONG ulDataLen, BYTE *pbEncryptedData, ULONG *pulEncryptedLen);


/*
*	ݵļܲ
ָԿָݽмܣܵݰ飬ܺı浽ָĻС
SKF_EncryptUpdateԶݽмܣڵSKF_EncryptUpdate֮ǰSKF_EncryptInitʼܲ
ڵSKF_EncryptUpdate֮󣬱SKF_EncryptFinalܲ
*	hKey			[IN] Կ
*	pbData			[IN] 
*	ulDataLen		[IN] ݳ
*	pbEncryptedData [OUT] ܺݻָ
*	pulEncryptedLen [OUT] ؼܺݳ
*/
ULONG DEVAPI SKF_EncryptUpdate(HANDLE hKey, BYTE * pbData, ULONG ulDataLen, BYTE *pbEncryptedData, ULONG *pulEncryptedLen);

/*
*	ݵļܣʣܽ
ȵSKF_EncryptInitʼܲ
ٵSKF_EncryptUpdateԶݽмܣ
SKF_EncryptFinalݵļܡ
*	hKey			[IN] Կ
*	pbEncryptedData [OUT] ܽĻ
*	pulEncryptedLen [OUT] ܽĳ
*/
ULONG DEVAPI SKF_EncryptFinal (HANDLE hKey, BYTE *pbEncryptedData, ULONG *ulEncryptedDataLen );

/*
*	ݽܳʼýԿز
SKF_DecryptInit֮󣬿ԵSKF_DecryptԵݽнܣ
ҲԶεSKF_DecryptUpdate֮ٵSKF_DecryptFinalɶԶݵĽܡ
*	hKey [IN] Կ
*	DecryptParam [IN] 㷨ز㷨ʶšԿȡʼʼȡ䷽ģʽֵλ
*/
ULONG DEVAPI SKF_DecryptInit (HANDLE hKey, BLOCKCIPHERPARAM DecryptParam);

/*
*	ݵĽܲ
ָԿָݽнܣֻܵһ飬ܺı浽ָĻ
SKF_DecryptֻԵݽнܣڵSKF_Decrypt֮ǰSKF_DecryptInitʼ
ܲ
SKF_DecyptȼȵSKF_DecryptUpdateٵSKF_DecryptFinal
*	hKey			[IN] Կ
*	pbEncryptedData [IN] 
*	ulEncryptedLen	[IN] ݳ
*	pbData			[OUT] ָܺݻָ룬ΪNULLʱɻýܺݳ
*	pulDataLen		[INOUT] ؽܺݳ
*/
ULONG DEVAPI SKF_Decrypt(HANDLE hKey, BYTE * pbEncryptedData, ULONG ulEncryptedLen, BYTE * pbData, ULONG * pulDataLen);

/*
*	ݵĽܲ
ָԿָݽнܣܵݰ飬ܺı浽ָĻС
SKF_DecryptUpdateԶݽнܣڵSKF_DecryptUpdate֮ǰSKF_DecryptInitʼܲ
ڵSKF_DecryptUpdate֮󣬱SKF_DecryptFinalܲ
*	hKey			[IN] Կ
*	pbEncryptedData [IN] 
*	ulEncryptedLen	[IN] ݳ
*	pbData			[OUT] ָܺݻָ
*	pulDataLen		[INOUT] ؽܺݳ
*/
ULONG DEVAPI SKF_DecryptUpdate(HANDLE hKey, BYTE * pbEncryptedData, ULONG ulEncryptedLen, BYTE * pbData, ULONG * pulDataLen);

/*
*	ݵĽܡ
*	hKey				[IN] Կ
*	pbPlainText			[OUT] ָܽĻ˲ΪNULLʱpulPlainTextLenؽܽĳ
*	pulDecyptedDataLen	[INOUT] ʱʾpbPlainTextĳȣؽܽĳ 
*/
ULONG DEVAPI SKF_DecryptFinal (HANDLE hKey, BYTE *pbDecryptedData, ULONG *pulDecryptedDataLen);

/*
*	ʼϢӴռָϢӴյ㷨
*	hDev			[IN] 豸ʱص豸
*	ulAlgID			[IN] Ӵ㷨ʶ
*	phHash			[OUT] Ӵն
*/
ULONG DEVAPI SKF_DigestInit(DEVHANDLE hDev, ULONG ulAlgID,  ECCPUBLICKEYBLOB *pPubKey, unsigned char *pucID, ULONG ulIDLen, HANDLE *phHash);

/*
*	ԵһϢӴռ㡣
*	hHash			[IN] Ӵն
*	pbData			[IN] ָϢݵĻ
*	ulDataLen		[IN] Ϣݵĳ
*	pbHashData		[OUT] Ӵݻָ룬˲ΪNULLʱpulHashLenӴսĳ
*	pulHashLen		[INOUT] ʱʾpbHashDataĳȣӴսĳ
*/
ULONG DEVAPI SKF_Digest (HANDLE hHash, BYTE *pbData, ULONG ulDataLen, BYTE *pbHashData, ULONG *pulHashLen);
/*
*	ԶϢӴռ㡣
*	hHash			[IN] Ӵն
*	pbPart			[IN] ָϢݵĻ
*	ulPartLen		[IN] Ϣݵĳ
*/
ULONG DEVAPI SKF_DigestUpdate (HANDLE hHash, BYTE *pbData, ULONG  ulDataLen);
/*
*	ϢӴռӴձ浽ָĻ
*	hHash			[IN] ϣ
*	pHashData		[OUT] صӴݻָ룬˲NULLʱpulHashLenӴսĳ
*	pulHashLen		[INOUT] ʱʾӴսĳȣӴݵĳ
*/
ULONG DEVAPI SKF_DigestFinal (HANDLE hHash, BYTE *pHashData, ULONG  *pulHashLen);

/*
*	ʼϢ֤üϢ֤ԿϢ֤
*	hKey			[IN] Ϣ֤Կ
*	MacParam		[IN] Ϣ֤زʼʼȡ䷽
*	phMac			[OUT] Ϣ֤
*/
ULONG DEVAPI SKF_MacInit (HANDLE hKey, BLOCKCIPHERPARAM* pMacParam, HANDLE *phMac);

/*
*	SKF_Mac㵥һݵϢ֤롣
*	hMac			[IN] Ϣ֤
*	pbData			[IN] ָݵĻ
*	ulDataLen		[IN] ݵĳ
*	pbMacData		[OUT] ָMac˲ΪNULLʱpulMacLenؼMacĳ
*	pulMacLen		[INOUT] ʱʾpbMacDataĳȣؼMacĳ
*/
ULONG DEVAPI SKF_Mac(HANDLE hMac, BYTE* pbData, ULONG ulDataLen, BYTE *pbMacData, ULONG *pulMacLen);
/*
*	ݵϢ֤롣
*	hMac			[IN] Ϣ֤
*	pbData			[IN] ָݵĻ
*	plDataLen		[IN] ݵĳ
*/
ULONG DEVAPI SKF_MacUpdate(HANDLE hMac, BYTE * pbData, ULONG ulDataLen);
/*
*	ݵϢ֤
*	hMac			[IN] Ϣ֤
*	pbMacData		[OUT] ָϢ֤Ļ˲ΪNULLʱpulMacDataLenϢ֤뷵صĳ
*	pulMacDataLen	[OUT] ʱʾϢ֤뻺󳤶ȣϢ֤ĳ
*/
ULONG DEVAPI SKF_MacFinal (HANDLE hMac, BYTE *pbMacData, ULONG *pulMacDataLen);
/*
*	رջỰԿӴաϢ֤
*	hHandle			[IN] ҪرյĶ
*/
ULONG DEVAPI SKF_CloseHandle(HANDLE hHandle);


/*****************************ΪûʹṩĲAPI********************************************/

/*
*	ĶԳԿԿ
*	hDev			[IN] 豸
*	pbKey			[IN] ָỰԿֵĻ
*	ulAlgID			[IN] ỰԿ㷨ʶ
*	phKey			[OUT] ػỰԿ
*/
ULONG DEVAPI SKF_SetSymmKey (DEVHANDLE hDev,  BYTE* pbKey, ULONG ulAlgID, HANDLE* phKey);


#ifdef __cplusplus
}
#endif


#endif //_SKFAPI_H_

